"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ignore_1 = require("../utils/ignore");
const findIndentifierDeclaration_1 = require("../utils/findIndentifierDeclaration");
const isExtendReactComponent_1 = require("../utils/isExtendReactComponent");
const _ = require("lodash");
const t = require("babel-types");
function default_1(ast) {
    let exportedComponent = null;
    function handleExportDefaultDeclaration(path) {
        const declaration = path.get('declaration');
        if (t.isClassDeclaration(declaration)) {
            exportedComponent = declaration;
        }
        else if (t.isIdentifier(declaration)) {
            exportedComponent = findIndentifierDeclaration_1.default(path, _.get(declaration, 'node.name'));
        }
        if (!isExtendReactComponent_1.default(exportedComponent)) {
            exportedComponent = null;
        }
    }
    ast.traverse({
        ImportDeclaration: ignore_1.default,
        VariableDeclaration: ignore_1.default,
        ExportNamedDeclaration: ignore_1.default,
        FunctionDeclaration: ignore_1.default,
        ExportDefaultDeclaration: handleExportDefaultDeclaration
    });
    return exportedComponent;
}
exports.default = default_1;
