"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
/**
 * 读取josn中的注释
 * @param path json代码的path
 */
function default_1(path) {
    const properties = _.get(path, 'node.properties');
    const result = {};
    if (!properties || properties.length === 0) {
        return result;
    }
    properties.forEach((prop) => {
        const key = _.get(prop, 'key.name');
        const descList = _.get(prop, 'leadingComments');
        if (descList && descList.length) {
            let desc = '';
            descList.forEach((d) => {
                // remove '*' in comment
                desc += d.value.replace(/(\*)*\s*\n\s*(\*)*/g, '\n');
            });
            result[key] = desc;
        }
    });
    return result;
}
exports.default = default_1;
