"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
let add_keys = new Map();
/**
 * 将对象映射到全局变量
 * @param obj 一个对象, key不得与global的key重名
 */
function assignToGlobal(obj) {
    for (let key of Object.keys(obj)) {
        if (!global[key]) {
            global[key] = obj[key];
            add_keys.set(key, true);
        }
    }
}
exports.assignToGlobal = assignToGlobal;
/**
 * 从global对象中移除属性, 前提是先通过assignToGlobal添加过
 * @param obj 一个对象
 */
function removeFromGlobal(obj) {
    for (let key of Object.keys(obj)) {
        if (global[key] && add_keys.get(key)) {
            delete global[key];
            add_keys.set(key, false);
        }
    }
}
exports.removeFromGlobal = removeFromGlobal;
